;; Pinaret - Static website generator
;; Copyright (C) 2016  Josep Portella Florit <hello@josep-portella.com>
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

#lang racket

(require "../runtime.rkt" "../procedure.rkt" "../system.rkt"
         "../command.rkt")

(main/defaults
 (let ([generators '()]
       [input-thunk #f])
   (command-line/defaults
    #:once-each
    [("--quiet" "-q") "Don't output file names" (quiet? #t)]
    [("--dummy" "-d") "Don't write any files" (dummy? #t)]
    [("--loop" "-l") "Keep generating as files change" (loop? #t)]
    #:multi
    [("--generator" "-g") g "Limit generation to the generator <g>"
     (set! generators (cons g generators))]
    #:once-each
    [("--input" "-i") i "Evaluate <i> instead of ${input}"
     (set! input-thunk (with-handlers ([error/params?
                                        (lambda (e)
                                          (print-error/params e)
                                          (exit))])
                         (thunk-maker->thunk (string->thunk-maker i))))]
    [("--repl-on-error" "-r") "Enter REPL on error" (repl-on-error? #t)])
   (generate generators input-thunk)))
