;; Pinaret - Static website generator
;; Copyright (C) 2016  Josep Portella Florit <hello@josep-portella.com>
;;
;; This program is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; This program is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <http://www.gnu.org/licenses/>.

#lang racket

(require "runtime.rkt" "procedure.rkt" "repl.rkt" "dict.rkt"
         "base.rkt" "system.rkt")
(provide
 ;; runtime
 apply-procedure
 call-procedure
 current-procedures
 current-recursion-limit
 define-procedure-group
 define-procedure-group/provide
 error/params?
 error/params-args
 error/params-params
 error/params-raiser
 procedure-ref
 procedure-ref/apply
 procedure-ref/call
 procedure-ref/forgive
 raise-error/params
 use-procedure-group

 ;; procedure
 application-end-char
 application-start-char
 escape-char
 filter-char
 interpolation-char
 quote-chars

 ;; repl
 repl-prompt
 repl-prompt*

 ;; dict
 comment-key
 key-char

 ;; base
 boolean->string
 call-extended
 call-extended*
 call-yield
 current-yield
 date->iso8601-string
 extended
 false-string
 local-key
 locals-key
 make-match-procedure
 pregexp*
 string->boolean
 string->divisor
 string->integer
 string->natural
 string->number*
 true-string

 ;; system
 bytes?-key
 dict-suffix
 ignore-file?
 index-file-key
 input-dir
 input-key
 library-dir
 mode-key
 omit-file?
 output-dir
 output-key
 path-key)
